function Calcul_erreur_champ_reel_radial()


for Interp_meth = {'bilinear', 'piecewise'}
    for GradProc_meth = {'none', 'correlation', 'median'}
        close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% RADIAL
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[X,Y] = meshgrid(linspace(-1,1,511), linspace(-1,1,511));
im = min(1, double(sqrt(X.^2 + Y.^2)));
[size_x, size_y] = size(im);
center_x = size_x/2;
center_y = size_y/2;
figure;
imshow(im);

im = 100*im; % Pour que le gradient ne passe pas en dessous du seuil 

param = GetDefaultParameters();

param.computeline.stopping.time.type = 'arc-length';
param.computeline.stopping.time.val = 100;
param.computeline.max_line_size = 50000;
param.computeline.direction = 'forward';



param.computeline.method = 'runge-kutta-45';

param.grad.interpolation_method = Interp_meth{1};
param.grad.processing_method = GradProc_meth{1};
dataname = sprintf('Radial_pratique__RK45_%s_%s_____', param.grad.interpolation_method, param.grad.processing_method);

param.display.linespec = '-r';

im_modif = InterpolateImage(im, param);
im_modif = ProcessImage(im_modif, param);
grad = ComputeGradient(im_modif, param);
grad = ProcessGradient(grad, param);
mask = InitializeMask(im, grad, param);
% SUSHI : RealGradient
grad = Make_circle_gradient( im, 'radial' );
space = linspace( 0, 90, 97 );
%space = space(1:end-1);
radius_initial = 50;
norm_grad = 1;
grad = norm_grad * grad;

figure(1);
imshow(im); hold on;
% 
% figure;
% imshow(im); hold on;
% for i = space
%     plot( [center_x; center_x + center_x*cosd(i)], ...
%                                        [center_y; center_y + center_x*sind(i)], '-b' );
% end
%     param.computeline.method = 'cauchy';    param.display.linespec = '-r';
%     param.computeline.time_step = 0.01;    
%     [error, lines] = error_curve_radial( space, radius_initial );
%     disp_lines( lines, param.display.linespec );
%     print_tikz_error( error, sprintf('data/%serror_rad_cauchy_1e-2_e%g.data',dataname,norm_grad) );
%     title('Cauchy 0.01');    
%     figure(1);
%     disp_lines( lines, '-c' );
%         
% figure(100);
% hold on;
% plot(error(:,1), error(:,2), '-b');
% hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
imshow(im); hold on;

for i = space
    plot( [center_x; center_x + center_x*cosd(i)], ...
                                       [center_y; center_y + center_x*sind(i)], '-b' );
end
    param.im.correlation = 0;
    param.im.median = 0;
    param.im.wiener = 0;
    im_modif = InterpolateImage(im, param);
    im_modif = ProcessImage(im_modif, param);
    grad = ComputeGradient(im_modif, param);
    grad = ProcessGradient(grad, param);
    [error, lines] = error_curve_radial( space, radius_initial );
    disp_lines( lines, param.display.linespec );
    print_tikz_error( error, sprintf('data/%serror_corr%d_med%d_wien%d.data',dataname, ...
        param.im.correlation, param.im.median, param.im.wiener) );
    title(sprintf('corr%d_med%d_wien%d', ...
        param.im.correlation, param.im.median, param.im.wiener));    
    figure(1);
    disp_lines( lines, '-b' );

figure(101);
hold on;
plot(error(:,1), error(:,2), '-k');
hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
imshow(im); hold on;

for i = space
    plot( [center_x; center_x + center_x*cosd(i)], ...
                                       [center_y; center_y + center_x*sind(i)], '-b' );
end
    param.im.correlation = 0;
    param.im.median = 1;
    param.im.wiener = 0;
    im_modif = InterpolateImage(im, param);
    im_modif = ProcessImage(im_modif, param);
    grad = ComputeGradient(im_modif, param);
    grad = ProcessGradient(grad, param);
    
    [error, lines] = error_curve_radial( space, radius_initial );
    disp_lines( lines, param.display.linespec );
    print_tikz_error( error, sprintf('data/%serror_corr%d_med%d_wien%d.data',dataname, ...
        param.im.correlation, param.im.median, param.im.wiener) );
    title(sprintf('corr%d_med%d_wien%d', ...
        param.im.correlation, param.im.median, param.im.wiener));    
    figure(1);
    disp_lines( lines, '-b' );

figure(101);
hold on;
plot(error(:,1), error(:,2), '-b');
hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
imshow(im); hold on;

for i = space
    plot( [center_x; center_x + center_x*cosd(i)], ...
                                       [center_y; center_y + center_x*sind(i)], '-b' );
end
    param.im.correlation = 0;
    param.im.median = 0;
    param.im.wiener = 1;
    im_modif = InterpolateImage(im, param);
    im_modif = ProcessImage(im_modif, param);
    grad = ComputeGradient(im_modif, param);
    grad = ProcessGradient(grad, param);
    
    [error, lines] = error_curve_radial( space, radius_initial );
    disp_lines( lines, param.display.linespec );
    print_tikz_error( error, sprintf('data/%serror_corr%d_med%d_wien%d.data',dataname, ...
        param.im.correlation, param.im.median, param.im.wiener) );
    title(sprintf('corr%d_med%d_wien%d', ...
        param.im.correlation, param.im.median, param.im.wiener));    
    figure(1);
    disp_lines( lines, '-b' );

figure(101);
hold on;
plot(error(:,1), error(:,2), '-g');
hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
imshow(im); hold on;

for i = space
    plot( [center_x; center_x + center_x*cosd(i)], ...
                                       [center_y; center_y + center_x*sind(i)], '-b' );
end
    param.im.correlation = 1;
    param.im.median = 0;
    param.im.wiener = 0;
    im_modif = InterpolateImage(im, param);
    im_modif = ProcessImage(im_modif, param);
    grad = ComputeGradient(im_modif, param);
    grad = ProcessGradient(grad, param);
    
    [error, lines] = error_curve_radial( space, radius_initial );
    disp_lines( lines, param.display.linespec );
    print_tikz_error( error, sprintf('data/%serror_corr%d_med%d_wien%d.data',dataname, ...
        param.im.correlation, param.im.median, param.im.wiener) );
    title(sprintf('corr%d_med%d_wien%d', ...
        param.im.correlation, param.im.median, param.im.wiener));    
    figure(1);
    disp_lines( lines, '-b' );

figure(101);
hold on;
plot(error(:,1), error(:,2), '-r');
hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
imshow(im); hold on;

for i = space
    plot( [center_x; center_x + center_x*cosd(i)], ...
                                       [center_y; center_y + center_x*sind(i)], '-b' );
end
    param.im.correlation = 1;
    param.im.median = 1;
    param.im.wiener = 0;
    im_modif = InterpolateImage(im, param);
    im_modif = ProcessImage(im_modif, param);
    grad = ComputeGradient(im_modif, param);
    grad = ProcessGradient(grad, param);
    
    [error, lines] = error_curve_radial( space, radius_initial );
    disp_lines( lines, param.display.linespec );
    print_tikz_error( error, sprintf('data/%serror_corr%d_med%d_wien%d.data',dataname, ...
        param.im.correlation, param.im.median, param.im.wiener) );
    title(sprintf('corr%d_med%d_wien%d', ...
        param.im.correlation, param.im.median, param.im.wiener));    
    figure(1);
    disp_lines( lines, '-b' );

figure(101);
hold on;
plot(error(:,1), error(:,2), '-m');
hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
imshow(im); hold on;

for i = space
    plot( [center_x; center_x + center_x*cosd(i)], ...
                                       [center_y; center_y + center_x*sind(i)], '-b' );
end
    param.im.correlation = 0;
    param.im.median = 1;
    param.im.wiener = 1;
    im_modif = InterpolateImage(im, param);
    im_modif = ProcessImage(im_modif, param);
    grad = ComputeGradient(im_modif, param);
    grad = ProcessGradient(grad, param);
    
    [error, lines] = error_curve_radial( space, radius_initial );
    disp_lines( lines, param.display.linespec );
    print_tikz_error( error, sprintf('data/%serror_corr%d_med%d_wien%d.data',dataname, ...
        param.im.correlation, param.im.median, param.im.wiener) );
    title(sprintf('corr%d_med%d_wien%d', ...
        param.im.correlation, param.im.median, param.im.wiener));    
    figure(1);
    disp_lines( lines, '-b' );

figure(101);
hold on;
plot(error(:,1), error(:,2), '-c');
hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
imshow(im); hold on;

for i = space
    plot( [center_x; center_x + center_x*cosd(i)], ...
                                       [center_y; center_y + center_x*sind(i)], '-b' );
end
    param.im.correlation = 1;
    param.im.median = 0;
    param.im.wiener = 1;
    im_modif = InterpolateImage(im, param);
    im_modif = ProcessImage(im_modif, param);
    grad = ComputeGradient(im_modif, param);
    grad = ProcessGradient(grad, param);
    
    [error, lines] = error_curve_radial( space, radius_initial );
    disp_lines( lines, param.display.linespec );
    print_tikz_error( error, sprintf('data/%serror_corr%d_med%d_wien%d.data',dataname, ...
        param.im.correlation, param.im.median, param.im.wiener) );
    title(sprintf('corr%d_med%d_wien%d', ...
        param.im.correlation, param.im.median, param.im.wiener));    
    figure(1);
    disp_lines( lines, '-b' );

figure(101);
hold on;
plot(error(:,1), error(:,2), '-y');
hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
imshow(im); hold on;

for i = space
    plot( [center_x; center_x + center_x*cosd(i)], ...
                                       [center_y; center_y + center_x*sind(i)], '-b' );
end
    param.im.correlation = 1;
    param.im.median = 1;
    param.im.wiener = 1;
    im_modif = InterpolateImage(im, param);
    im_modif = ProcessImage(im_modif, param);
    grad = ComputeGradient(im_modif, param);
    grad = ProcessGradient(grad, param);
    
    [error, lines] = error_curve_radial( space, radius_initial );
    disp_lines( lines, param.display.linespec );
    print_tikz_error( error, sprintf('data/%serror_corr%d_med%d_wien%d.data',dataname, ...
        param.im.correlation, param.im.median, param.im.wiener) );
    title(sprintf('corr%d_med%d_wien%d', ...
        param.im.correlation, param.im.median, param.im.wiener));    
    figure(1);
    disp_lines( lines, '-b' );

figure(101);
hold on;
plot(error(:,1), error(:,2), ':k');
hold off;



legend('Aucun', 'Median', 'Wiener', 'Corr.', 'Median/Corr.', 'Median/Wiener', 'Corr./Wiener', 'Corr./Median/Wiener');
    end;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Local function

    function lines = circle_lines(space)                             %#ok<DEFNU>
        lines = cell(size(10:space:center_y-10));
        k = 1;
        for radius = 10:space:center_y-10
            x_0 = [ center_x - radius; center_y ];
            line = ComputeLine(x_0, grad, mask, param);
            lines{k} = line;
            k = k+1;
        end
    end

    function error = error_line_circle( center, radius, line )
        line = line - repmat( center, 1, size(line, 2) );
        % Norme L1 vvv
        foo = abs(sqrt(line(1,:).^2 + line(2,:).^2) - radius);
        
        linesize = sqrt( ( line(1,2:end) - line(1,1:end-1) ).^2 + ...
            ( line(2,2:end) - line(2,1:end-1) ).^2 );
        error = sum( linesize .* foo(2:end) ) / sum(linesize); 
    end

    function [errors,lines] = error_curve_circle(space)
        errors = zeros(length(space),2);
        lines = cell(length(space),1);
        k = 1;
        for radius = space
            x_0 = [ center_x + 2; center_y - radius];
            line = ComputeLine(x_0, grad, mask, param);
            errors(k,1) = radius;
            errors(k,2) = error_line_circle( [center_x; center_y], radius, line );
            lines{k} = line;
            k = k+1;
        end
        fprintf('\n');
    end

    function error = error_line_radius( center, angle, line )
        line = line - repmat( center, 1, size(line, 2) );
        % Norme L1 vvv
        norm = sqrt(line(1,:).^2 + line(2,:).^2);
        foo = 180*(atan2(line(2,:),line(1,:)))/pi - angle;
        foo = abs( mod( foo + 180, 360) - 180 );
        foo = min(max(foo,-90), 90);
        foo = norm .* sind(foo);
        
        linesize = sqrt( ( line(1,2:end) - line(1,1:end-1) ).^2 + ...
            ( line(2,2:end) - line(2,1:end-1) ).^2 );
        error = sum( linesize .* foo(2:end) ) / sum(linesize);
    end

    function [errors, lines] = error_curve_radial(space, radius)
        errors = zeros(length(space),2);
        lines = cell(length(space),1);
        k = 1;
        for angle = space
            x_0 = [ center_x + radius*cosd(angle); center_y + radius*sind(angle)];
            plot(x_0(1),x_0(2),'o', 'LineWidth',4);
            line = ComputeLine(x_0, grad, mask, param);
            errors(k,1) = angle;
            errors(k,2) = error_line_radius( [center_x; center_y], angle, line );
            lines{k} = line;
            k = k+1;
        end
        fprintf('\n');
    end

end

%% ------- -- -- -  -                                      -  - -- -- --------%%
%---- -- -  -                  FONCTIONS LOCALES                   -  - -- ----%
%%-------- -- -- -  -                                      -  - -- -- ------- %%

function plot_circle( center, rayon, dmax, nb_point )
    line = zeros( nb_point, 2 );
    i = 1;
    for angle = linspace( 0, min(180,dmax / rayon), nb_point );
        line(i,1) = center(1) + rayon*cosd(angle-90);
        line(i,2) = center(2) + rayon*sind(angle-90);
        i = i+1;
    end
    plot( line(:,1)+.5, line(:,2)+.5, '-g' );
end

%% --------- ---- -  -                                    -  - ---- --------- %%

function disp_lines( lines, color )
    for i = 1:length(lines)
        line = lines{i};
        %line = line + 0.5;
        plot(line(1,:), line(2,:), color);
    end
end

%% --------- ---- -  -                                    -  - ---- --------- %%

function print_tikz_error( error, nom )

    fileID = fopen(nom, 'w');
    for i = 1:size(error,1)
        fprintf(fileID, '%2.6f\t%2.6f\n', error(i,1), error(i,2));
    end
    fclose( fileID );

end